/* $B%G!<%?%\%C%/%9%i%$%V%i%j%X%C%@(B ver1.1 1997/8/2
                  by Y.Shigesada                   */

#include<basic.h>
#include<btron/libapp.h>
#include<tcode.h>
#include<btron/dp.h>
#include<btron/taddata.h>
#include<btron/memory.h>
#include<bstdlib.h>

/* $B%7!<%s%G!<%?$N%G!<%?9=B$(B
   $B%7!<%s%G!<%?$O%?%$%W(B31$B$N%l%3!<%I$K5-=R$9$k(B
   $B:G=i$N(B10$BJ8;z(B x.x $B$O%P!<%8%g%sHV9f(B
   SDATver1.3
   
   W   $B%7!<%sHV9f(B(-1$B$O%G!<%?$N=*N;$rI=$9(B)
   W   $B%7!<%s$N%G!<%??t(B

   W   $B%?%$%W(B
   W   ID
   PNT $BI=<(:8>e:BI8(B
   W   $B%Q!<%D3JG<G[NsHV9f(B
   $B$3$l$r$=$N%7!<%s%G!<%?$N?t$@$17+$jJV$9(B
   */

#define MAXSCENENUM 256

typedef struct {
    W    type;
    W    id;
    RECT r;
    W    pnum;
} SCENEDATAver1_0;

typedef struct {
    UH   type;
    UW   id;
    RECT r;
    UH   pnum;
    UB	 mojifgcolor;
    UB	 mojibgcolor;
    UB   mojisizex;
    UB   mojisizey;
    UW   mojiattr;
} SCENEDATAver1_1;

typedef struct {
    UB   type;
    UW   id;
    RECT r;
    UH   pnum;
    UB   dispmode;
    UB	 mojifgcolor;
    UB	 mojibgcolor;
    UB   mojisizex;
    UB   mojisizey;
    UW   mojiattr;
} SCENEDATAver1_2;

typedef struct {
    UB   type;
    UW   id;
    RECT r;
    UH   pnum;
    UB   dispmode;
    H	 mojifgcolor;
    H	 mojibgcolor;
    UB   mojisizex;
    UB   mojisizey;
    UW   mojiattr;
} SCENEDATAver1_3;

typedef struct {
    UB   type;
    UW   id;
    RECT r;
    UH   pnum;
    UB   dispmode;
    COLOR mojifgcolor;
    COLOR mojibgcolor;
    UB   mojisizex;
    UB   mojisizey;
    UW   mojiattr;
} SCENEDATAver1_4;

struct {
    W	      num;
    SCENEDATAver1_4 *sdat;
} scenedata[MAXSCENENUM];

typedef struct __DATATREE {
    W      id;                  /* ID */
    B	   *ptr;		/* $B%G!<%?$X$N%]%$%s%?(B */
    struct __DATATREE *stree;   /* $B<+J,$N(BID$B$h$j>.$5$$(BID$B$r(B
				   $B;}$D(BDATAREE$B$X$N%]%$%s%?(B */
    struct __DATATREE *ltree;   /* $B<+J,$N(BID$B$h$jBg$-$$(BID$B$r(B
				   $B;}$D(BDATATREE$B$X$N%]%$%s%?(B */
} DATATREE;

/* $B3F%?%$%W$N%G!<%?%\%C%/%9%G!<%?$r3JG<$9$k%D%j!<$N%k!<%H(B */
DATATREE *root[11];

void inittreedata();
void loadscenedata(W fd);
void displayscene(W wid, W scenenum, W *pid, W pmax, RECT *hr);
W searchtree(W type, W id, B **ptr);
void displaypatdatafromid(W gid, W id, RECT *r, W dispmode);
void displaypictdatafromid(W gid, W id, RECT *r, W dispmode);
void displaybmpdatafromid(W gid, W id, RECT *r, W dispmode);
void displayfigdatafromid(W gid, W id, RECT *rptr);
void displaytextdatafromid(W gid, W id, RECT *r, W dispmode, W attr, PNT *mojisize,
		     W fgcolor, W bgcolor);
void createpartsdatafromid(W wid, W id, RECT *r, W *pid);
void displaynodata(W gid, RECT *r);
BMP *getscreentypebmp(BMP *bmp);
UB getcolmap16(H col);
UB getcolmap24(W col);
UH get16colfromcmap(B col);
UH get16colfrom32(W col);
COLOR get32colfrom16(H col);
